package org.processmining.baseminers.algorithms;

import java.util.Set;

import org.deckfour.xes.classification.XEventClassifier;
import org.deckfour.xes.model.XLog;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.plugins.transitionsystem.converter.util.TSConversions;
import org.processmining.plugins.transitionsystem.miner.TSMinerInput;
import org.processmining.plugins.transitionsystem.miner.modir.TSMinerModirInput;
import org.processmining.plugins.transitionsystem.miner.util.TSAbstractions;
import org.processmining.plugins.transitionsystem.miner.util.TSDirections;

public class FlowerMinerAlgorithm extends AbstractMinerAlgorithm {

	public TSMinerInput getInput(PluginContext context, XLog log, Set<XEventClassifier> classifiers, XEventClassifier classifier) {
		TSMinerInput input = new TSMinerInput(context, log, classifiers, classifier);
		input.getConverterSettings().setUse(TSConversions.KILLSELFLOOPS, false);
		TSMinerModirInput modirInput = new TSMinerModirInput();
		modirInput.setUse(true);
		modirInput.setAbstraction(TSAbstractions.SEQUENCE);
		modirInput.setFilteredHorizon(-1);
		modirInput.setHorizon(1);
		input.setModirSettings(TSDirections.BACKWARD, classifier, modirInput);
		return input;
	}

}
