package org.processmining.baseminers.algorithms;

import java.util.Set;

import org.deckfour.xes.classification.XEventClass;
import org.deckfour.xes.classification.XEventClassifier;
import org.deckfour.xes.info.XLogInfo;
import org.deckfour.xes.info.XLogInfoFactory;
import org.deckfour.xes.model.XLog;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.plugins.transitionsystem.miner.TSMinerInput;
import org.processmining.plugins.transitionsystem.miner.modir.TSMinerModirInput;
import org.processmining.plugins.transitionsystem.miner.util.TSAbstractions;
import org.processmining.plugins.transitionsystem.miner.util.TSDirections;

public class TraceMinerAlgorithm extends AbstractMinerAlgorithm {

	public TSMinerInput getInput(PluginContext context, XLog log, Set<XEventClassifier> classifiers, XEventClassifier classifier) {
		TSMinerInput input = new TSMinerInput(context, log, classifiers, classifier);
		TSMinerModirInput modirInput = new TSMinerModirInput();
		modirInput.setUse(true);
		modirInput.setAbstraction(TSAbstractions.SEQUENCE);
		modirInput.setFilteredHorizon(-1);
		modirInput.setHorizon(-1);
		XLogInfo info = XLogInfoFactory.createLogInfo(log, classifier);
		for (XEventClass eventClass : info.getEventClasses().getClasses()) {
			modirInput.getFilter().add(eventClass.getId());
		}
		input.setModirSettings(TSDirections.BACKWARD, classifier, modirInput);
//		input.setModirSettings(TSDirections.FORWARD, classifier, modirInput);
		input.setMaxStates(Integer.MAX_VALUE);
//		input.getConverterSettings().setUse(TSConversions.MERGEBYOUTPUT, true);
		return input;
	}

}
