package org.processmining.baseminers.plugins;

import org.deckfour.xes.classification.XEventAndClassifier;
import org.deckfour.xes.classification.XEventClassifier;
import org.deckfour.xes.classification.XEventLifeTransClassifier;
import org.deckfour.xes.classification.XEventNameClassifier;
import org.deckfour.xes.model.XLog;
import org.processmining.baseminers.algorithms.DirectlyFollowsFilteredMinerAlgorithm;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginLevel;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.models.graphbased.directed.petrinet.Petrinet;

@Plugin(name = "Discover Petri Net using Directly-Follows Miner with 100% Filter", level = PluginLevel.Regular, parameterLabels = {
"Log" }, returnLabels = { "Petri Net" }, returnTypes = { Petrinet.class }, userAccessible = true, help = "")
public class DirectlyFollowsMinerHundredFilterPlugin extends DirectlyFollowsFilteredMinerAlgorithm {

	public DirectlyFollowsMinerHundredFilterPlugin() {
		super(100);
	}
	
	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "H.M.W. Verbeek", email = "h.m.w.verbeek@tue.nl")
	@PluginVariant(variantLabel = "Discover Petri Net using Directly-Follows Miner with 100% Filter", requiredParameterLabels = { 0 })
	public Petrinet run(PluginContext context, XLog log) {
		XEventClassifier classifier = (log.getClassifiers().size() > 0 ? log.getClassifiers().get(0) : new XEventAndClassifier(new XEventNameClassifier(), new XEventLifeTransClassifier()));
		return apply(context, log, classifier);
	}
}
